From 3277c2359369b1adee76d4e065f723c883ad2b6f Mon Sep 17 00:00:00 2001
From: John Naylor <john.naylor@postgresql.org>
Date: Sat, 9 Jul 2022 12:19:18 +0700
Subject: [PATCH v1 1/2] Transform GETSTRUCT macro so the cast is built in

Per suggestion from Andres Freund
---
 contrib/bloom/blvalidate.c                    |   8 +-
 contrib/dblink/dblink.c                       |   2 +-
 contrib/intarray/_int_selfuncs.c              |   2 +-
 contrib/postgres_fdw/deparse.c                |   8 +-
 contrib/sepgsql/database.c                    |   2 +-
 contrib/sepgsql/dml.c                         |   4 +-
 contrib/sepgsql/label.c                       |  10 +-
 contrib/sepgsql/proc.c                        |   6 +-
 contrib/sepgsql/relation.c                    |  12 +-
 contrib/sepgsql/schema.c                      |   2 +-
 contrib/tcn/tcn.c                             |   2 +-
 src/backend/access/brin/brin_validate.c       |   8 +-
 src/backend/access/common/reloptions.c        |   2 +-
 src/backend/access/common/tupdesc.c           |   2 +-
 src/backend/access/gin/ginvalidate.c          |   8 +-
 src/backend/access/gist/gistvalidate.c        |   8 +-
 src/backend/access/hash/hashvalidate.c        |  10 +-
 src/backend/access/index/amapi.c              |   4 +-
 src/backend/access/index/amvalidate.c         |  14 +-
 src/backend/access/nbtree/nbtvalidate.c       |   8 +-
 src/backend/access/spgist/spgutils.c          |   4 +-
 src/backend/access/spgist/spgvalidate.c       |   8 +-
 src/backend/bootstrap/bootstrap.c             |   2 +-
 src/backend/catalog/aclchk.c                  | 118 ++++-----
 src/backend/catalog/catalog.c                 |   2 +-
 src/backend/catalog/dependency.c              |   4 +-
 src/backend/catalog/heap.c                    |  24 +-
 src/backend/catalog/index.c                   |  40 +--
 src/backend/catalog/namespace.c               |  40 +--
 src/backend/catalog/objectaddress.c           | 124 ++++-----
 src/backend/catalog/partition.c               |   8 +-
 src/backend/catalog/pg_aggregate.c            |   8 +-
 src/backend/catalog/pg_attrdef.c              |  14 +-
 src/backend/catalog/pg_constraint.c           |  28 +-
 src/backend/catalog/pg_conversion.c           |   2 +-
 src/backend/catalog/pg_depend.c               |  26 +-
 src/backend/catalog/pg_enum.c                 |  20 +-
 src/backend/catalog/pg_inherits.c             |  14 +-
 src/backend/catalog/pg_operator.c             |   8 +-
 src/backend/catalog/pg_proc.c                 |   6 +-
 src/backend/catalog/pg_publication.c          |  22 +-
 src/backend/catalog/pg_shdepend.c             |  14 +-
 src/backend/catalog/pg_subscription.c         |  12 +-
 src/backend/catalog/pg_type.c                 |   6 +-
 src/backend/catalog/toasting.c                |   2 +-
 src/backend/commands/alter.c                  |  16 +-
 src/backend/commands/amcmds.c                 |   4 +-
 src/backend/commands/analyze.c                |   2 +-
 src/backend/commands/cluster.c                |  12 +-
 src/backend/commands/collationcmds.c          |  10 +-
 src/backend/commands/dbcommands.c             |  28 +-
 src/backend/commands/event_trigger.c          |   6 +-
 src/backend/commands/extension.c              |  14 +-
 src/backend/commands/foreigncmds.c            |  12 +-
 src/backend/commands/functioncmds.c           |  22 +-
 src/backend/commands/indexcmds.c              |  24 +-
 src/backend/commands/matview.c                |   4 +-
 src/backend/commands/opclasscmds.c            |  20 +-
 src/backend/commands/operatorcmds.c           |   4 +-
 src/backend/commands/policy.c                 |  16 +-
 src/backend/commands/proclang.c               |   2 +-
 src/backend/commands/publicationcmds.c        |  22 +-
 src/backend/commands/schemacmds.c             |   8 +-
 src/backend/commands/sequence.c               |  18 +-
 src/backend/commands/statscmds.c              |   6 +-
 src/backend/commands/subscriptioncmds.c       |   8 +-
 src/backend/commands/tablecmds.c              | 240 +++++++++---------
 src/backend/commands/tablespace.c             |  10 +-
 src/backend/commands/trigger.c                |  34 +--
 src/backend/commands/tsearchcmds.c            |  26 +-
 src/backend/commands/typecmds.c               |  42 +--
 src/backend/commands/user.c                   |  14 +-
 src/backend/commands/vacuum.c                 |  12 +-
 src/backend/commands/variable.c               |   4 +-
 src/backend/executor/execAmi.c                |   2 +-
 src/backend/executor/functions.c              |   4 +-
 src/backend/executor/nodeAgg.c                |   4 +-
 src/backend/executor/nodeWindowAgg.c          |   4 +-
 src/backend/executor/spi.c                    |   2 +-
 src/backend/foreign/foreign.c                 |  14 +-
 src/backend/optimizer/plan/planagg.c          |   2 +-
 src/backend/optimizer/plan/subselect.c        |   2 +-
 src/backend/optimizer/prep/prepagg.c          |   2 +-
 src/backend/optimizer/util/appendinfo.c       |   2 +-
 src/backend/optimizer/util/clauses.c          |  14 +-
 src/backend/optimizer/util/plancat.c          |   8 +-
 src/backend/parser/parse_clause.c             |   2 +-
 src/backend/parser/parse_coerce.c             |  12 +-
 src/backend/parser/parse_func.c               |   6 +-
 src/backend/parser/parse_oper.c               |  10 +-
 src/backend/parser/parse_relation.c           |   2 +-
 src/backend/parser/parse_type.c               |  32 +--
 src/backend/parser/parse_utilcmd.c            |  22 +-
 src/backend/postmaster/autovacuum.c           |  20 +-
 src/backend/replication/logical/launcher.c    |   2 +-
 src/backend/replication/logical/origin.c      |   4 +-
 src/backend/replication/logical/proto.c       |   4 +-
 src/backend/replication/logical/worker.c      |   2 +-
 src/backend/rewrite/rewriteDefine.c           |  10 +-
 src/backend/rewrite/rewriteRemove.c           |   2 +-
 src/backend/rewrite/rewriteSupport.c          |   4 +-
 src/backend/statistics/extended_stats.c       |   6 +-
 src/backend/storage/large_object/inv_api.c    |   8 +-
 src/backend/tcop/fastpath.c                   |   2 +-
 src/backend/tsearch/ts_selfuncs.c             |   2 +-
 src/backend/utils/adt/acl.c                   |  16 +-
 src/backend/utils/adt/amutils.c               |   4 +-
 src/backend/utils/adt/array_selfuncs.c        |   4 +-
 src/backend/utils/adt/dbsize.c                |   4 +-
 src/backend/utils/adt/domains.c               |   2 +-
 src/backend/utils/adt/enum.c                  |  16 +-
 src/backend/utils/adt/format_type.c           |   4 +-
 src/backend/utils/adt/jsonfuncs.c             |   2 +-
 src/backend/utils/adt/like_support.c          |   2 +-
 .../utils/adt/multirangetypes_selfuncs.c      |   2 +-
 src/backend/utils/adt/network_selfuncs.c      |  10 +-
 src/backend/utils/adt/pg_locale.c             |   4 +-
 src/backend/utils/adt/rangetypes_selfuncs.c   |   2 +-
 src/backend/utils/adt/regproc.c               |  22 +-
 src/backend/utils/adt/ri_triggers.c           |   6 +-
 src/backend/utils/adt/ruleutils.c             |  54 ++--
 src/backend/utils/adt/selfuncs.c              |  28 +-
 src/backend/utils/adt/xml.c                   |   4 +-
 src/backend/utils/cache/evtcache.c            |   2 +-
 src/backend/utils/cache/inval.c               |  10 +-
 src/backend/utils/cache/lsyscache.c           | 196 +++++++-------
 src/backend/utils/cache/partcache.c           |   4 +-
 src/backend/utils/cache/relcache.c            |  44 ++--
 src/backend/utils/cache/relfilenumbermap.c    |   2 +-
 src/backend/utils/cache/syscache.c            |   4 +-
 src/backend/utils/cache/ts_cache.c            |  12 +-
 src/backend/utils/cache/typcache.c            |  12 +-
 src/backend/utils/fmgr/fmgr.c                 |  18 +-
 src/backend/utils/fmgr/funcapi.c              |   6 +-
 src/backend/utils/init/miscinit.c             |   6 +-
 src/backend/utils/init/postinit.c             |  10 +-
 src/backend/utils/misc/rls.c                  |   2 +-
 src/backend/utils/misc/superuser.c            |   2 +-
 src/include/access/htup_details.h             |   2 +-
 src/pl/plperl/plperl.c                        |  10 +-
 src/pl/plpgsql/src/pl_comp.c                  |  14 +-
 src/pl/plpgsql/src/pl_handler.c               |   2 +-
 src/pl/plpython/plpy_main.c                   |   2 +-
 src/pl/plpython/plpy_procedure.c              |   6 +-
 src/pl/tcl/pltcl.c                            |   8 +-
 src/test/modules/plsample/plsample.c          |   8 +-
 146 files changed, 1049 insertions(+), 1049 deletions(-)

diff --git a/contrib/bloom/blvalidate.c b/contrib/bloom/blvalidate.c
index 333a35d377..fc9911d6bf 100644
--- a/contrib/bloom/blvalidate.c
+++ b/contrib/bloom/blvalidate.c
@@ -52,7 +52,7 @@ blvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -65,7 +65,7 @@ blvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -77,7 +77,7 @@ blvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/*
@@ -138,7 +138,7 @@ blvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 
 		/* Check it's allowed strategy for bloom */
 		if (oprform->amopstrategy < 1 ||
diff --git a/contrib/dblink/dblink.c b/contrib/dblink/dblink.c
index e323fdd0e6..faa2a07da2 100644
--- a/contrib/dblink/dblink.c
+++ b/contrib/dblink/dblink.c
@@ -2075,7 +2075,7 @@ get_pkey_attnames(Relation rel, int16 *indnkeyatts)
 
 	while (HeapTupleIsValid(indexTuple = systable_getnext(scan)))
 	{
-		Form_pg_index index = (Form_pg_index) GETSTRUCT(indexTuple);
+		Form_pg_index index = GETSTRUCT(pg_index, indexTuple);
 
 		/* we're only interested if it is the primary key */
 		if (index->indisprimary)
diff --git a/contrib/intarray/_int_selfuncs.c b/contrib/intarray/_int_selfuncs.c
index 3d8ff6781b..a66d5fee92 100644
--- a/contrib/intarray/_int_selfuncs.c
+++ b/contrib/intarray/_int_selfuncs.c
@@ -191,7 +191,7 @@ _int_matchsel(PG_FUNCTION_ARGS)
 	{
 		Form_pg_statistic stats;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 		nullfrac = stats->stanullfrac;
 
 		/*
diff --git a/contrib/postgres_fdw/deparse.c b/contrib/postgres_fdw/deparse.c
index 8f4d8a5022..63dc4e8c55 100644
--- a/contrib/postgres_fdw/deparse.c
+++ b/contrib/postgres_fdw/deparse.c
@@ -3005,7 +3005,7 @@ deparseOpExpr(OpExpr *node, deparse_expr_cxt *context)
 	tuple = SearchSysCache1(OPEROID, ObjectIdGetDatum(node->opno));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for operator %u", node->opno);
-	form = (Form_pg_operator) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_operator, tuple);
 	oprkind = form->oprkind;
 
 	/* Sanity check. */
@@ -3180,7 +3180,7 @@ deparseScalarArrayOpExpr(ScalarArrayOpExpr *node, deparse_expr_cxt *context)
 	tuple = SearchSysCache1(OPEROID, ObjectIdGetDatum(node->opno));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for operator %u", node->opno);
-	form = (Form_pg_operator) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_operator, tuple);
 
 	/* Sanity check. */
 	Assert(list_length(node->args) == 2);
@@ -3519,7 +3519,7 @@ appendOrderBySuffix(Oid sortop, Oid sortcoltype, bool nulls_first,
 		opertup = SearchSysCache1(OPEROID, ObjectIdGetDatum(sortop));
 		if (!HeapTupleIsValid(opertup))
 			elog(ERROR, "cache lookup failed for operator %u", sortop);
-		operform = (Form_pg_operator) GETSTRUCT(opertup);
+		operform = GETSTRUCT(pg_operator, opertup);
 		deparseOperatorName(buf, operform);
 		ReleaseSysCache(opertup);
 	}
@@ -3734,7 +3734,7 @@ appendFunctionName(Oid funcid, deparse_expr_cxt *context)
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 
 	/* Print schema name only if it's not pg_catalog */
 	if (procform->pronamespace != PG_CATALOG_NAMESPACE)
diff --git a/contrib/sepgsql/database.c b/contrib/sepgsql/database.c
index dce97859f4..a73d600cb8 100644
--- a/contrib/sepgsql/database.c
+++ b/contrib/sepgsql/database.c
@@ -89,7 +89,7 @@ sepgsql_database_post_create(Oid databaseId, const char *dtemplate)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for database %u", databaseId);
 
-	datForm = (Form_pg_database) GETSTRUCT(tuple);
+	datForm = GETSTRUCT(pg_database, tuple);
 
 	ncontext = sepgsql_compute_create(sepgsql_get_client_label(),
 									  tcontext,
diff --git a/contrib/sepgsql/dml.c b/contrib/sepgsql/dml.c
index 3bb98dfb06..114a46c2db 100644
--- a/contrib/sepgsql/dml.c
+++ b/contrib/sepgsql/dml.c
@@ -52,7 +52,7 @@ fixup_whole_row_references(Oid relOid, Bitmapset *columns)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relOid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relOid);
-	natts = ((Form_pg_class) GETSTRUCT(tuple))->relnatts;
+	natts = (GETSTRUCT(pg_class, tuple))->relnatts;
 	ReleaseSysCache(tuple);
 
 	/* remove bit 0 from column set, add in all the non-dropped columns */
@@ -67,7 +67,7 @@ fixup_whole_row_references(Oid relOid, Bitmapset *columns)
 		if (!HeapTupleIsValid(tuple))
 			continue;			/* unexpected case, should we error? */
 
-		if (!((Form_pg_attribute) GETSTRUCT(tuple))->attisdropped)
+		if (!(GETSTRUCT(pg_attribute, tuple))->attisdropped)
 		{
 			index = attno - FirstLowInvalidHeapAttributeNumber;
 			result = bms_add_member(result, index);
diff --git a/contrib/sepgsql/label.c b/contrib/sepgsql/label.c
index e4c98b7eae..a7dd60fb90 100644
--- a/contrib/sepgsql/label.c
+++ b/contrib/sepgsql/label.c
@@ -733,7 +733,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 		switch (catalogId)
 		{
 			case DatabaseRelationId:
-				datForm = (Form_pg_database) GETSTRUCT(tuple);
+				datForm = GETSTRUCT(pg_database, tuple);
 
 				objtype = SELABEL_DB_DATABASE;
 
@@ -746,7 +746,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				break;
 
 			case NamespaceRelationId:
-				nspForm = (Form_pg_namespace) GETSTRUCT(tuple);
+				nspForm = GETSTRUCT(pg_namespace, tuple);
 
 				objtype = SELABEL_DB_SCHEMA;
 
@@ -760,7 +760,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				break;
 
 			case RelationRelationId:
-				relForm = (Form_pg_class) GETSTRUCT(tuple);
+				relForm = GETSTRUCT(pg_class, tuple);
 
 				if (relForm->relkind == RELKIND_RELATION ||
 					relForm->relkind == RELKIND_PARTITIONED_TABLE)
@@ -785,7 +785,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				break;
 
 			case AttributeRelationId:
-				attForm = (Form_pg_attribute) GETSTRUCT(tuple);
+				attForm = GETSTRUCT(pg_attribute, tuple);
 
 				if (get_rel_relkind(attForm->attrelid) != RELKIND_RELATION &&
 					get_rel_relkind(attForm->attrelid) != RELKIND_PARTITIONED_TABLE)
@@ -809,7 +809,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				break;
 
 			case ProcedureRelationId:
-				proForm = (Form_pg_proc) GETSTRUCT(tuple);
+				proForm = GETSTRUCT(pg_proc, tuple);
 
 				objtype = SELABEL_DB_PROCEDURE;
 
diff --git a/contrib/sepgsql/proc.c b/contrib/sepgsql/proc.c
index 45f006ed2a..54446cb02d 100644
--- a/contrib/sepgsql/proc.c
+++ b/contrib/sepgsql/proc.c
@@ -68,7 +68,7 @@ sepgsql_proc_post_create(Oid functionId)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for function %u", functionId);
 
-	proForm = (Form_pg_proc) GETSTRUCT(tuple);
+	proForm = GETSTRUCT(pg_proc, tuple);
 
 	/*
 	 * check db_schema:{add_name} permission of the namespace
@@ -260,7 +260,7 @@ sepgsql_proc_setattr(Oid functionId)
 	newtup = systable_getnext(sscan);
 	if (!HeapTupleIsValid(newtup))
 		elog(ERROR, "could not find tuple for function %u", functionId);
-	newform = (Form_pg_proc) GETSTRUCT(newtup);
+	newform = GETSTRUCT(pg_proc, newtup);
 
 	/*
 	 * Fetch older catalog
@@ -268,7 +268,7 @@ sepgsql_proc_setattr(Oid functionId)
 	oldtup = SearchSysCache1(PROCOID, ObjectIdGetDatum(functionId));
 	if (!HeapTupleIsValid(oldtup))
 		elog(ERROR, "cache lookup failed for function %u", functionId);
-	oldform = (Form_pg_proc) GETSTRUCT(oldtup);
+	oldform = GETSTRUCT(pg_proc, oldtup);
 
 	/*
 	 * Does this ALTER command takes operation to namespace?
diff --git a/contrib/sepgsql/relation.c b/contrib/sepgsql/relation.c
index 8767988c4d..1d79397448 100644
--- a/contrib/sepgsql/relation.c
+++ b/contrib/sepgsql/relation.c
@@ -84,7 +84,7 @@ sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum)
 		elog(ERROR, "could not find tuple for column %d of relation %u",
 			 attnum, relOid);
 
-	attForm = (Form_pg_attribute) GETSTRUCT(tuple);
+	attForm = GETSTRUCT(pg_attribute, tuple);
 
 	scontext = sepgsql_get_client_label();
 	tcontext = sepgsql_get_label(RelationRelationId, relOid, 0);
@@ -271,7 +271,7 @@ sepgsql_relation_post_create(Oid relOid)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for relation %u", relOid);
 
-	classForm = (Form_pg_class) GETSTRUCT(tuple);
+	classForm = GETSTRUCT(pg_class, tuple);
 
 	/* ignore indexes on toast tables */
 	if (classForm->relkind == RELKIND_INDEX &&
@@ -368,7 +368,7 @@ sepgsql_relation_post_create(Oid relOid)
 
 		while (HeapTupleIsValid(atup = systable_getnext(ascan)))
 		{
-			attForm = (Form_pg_attribute) GETSTRUCT(atup);
+			attForm = GETSTRUCT(pg_attribute, atup);
 
 			resetStringInfo(&audit_name);
 			appendStringInfo(&audit_name, "%s.%s.%s",
@@ -494,7 +494,7 @@ sepgsql_relation_drop(Oid relOid)
 		for (i = 0; i < attrList->n_members; i++)
 		{
 			atttup = &attrList->members[i]->tuple;
-			attForm = (Form_pg_attribute) GETSTRUCT(atttup);
+			attForm = GETSTRUCT(pg_attribute, atttup);
 
 			if (attForm->attisdropped)
 				continue;
@@ -662,7 +662,7 @@ sepgsql_relation_setattr(Oid relOid)
 	newtup = systable_getnext(sscan);
 	if (!HeapTupleIsValid(newtup))
 		elog(ERROR, "could not find tuple for relation %u", relOid);
-	newform = (Form_pg_class) GETSTRUCT(newtup);
+	newform = GETSTRUCT(pg_class, newtup);
 
 	/*
 	 * Fetch older catalog
@@ -670,7 +670,7 @@ sepgsql_relation_setattr(Oid relOid)
 	oldtup = SearchSysCache1(RELOID, ObjectIdGetDatum(relOid));
 	if (!HeapTupleIsValid(oldtup))
 		elog(ERROR, "cache lookup failed for relation %u", relOid);
-	oldform = (Form_pg_class) GETSTRUCT(oldtup);
+	oldform = GETSTRUCT(pg_class, oldtup);
 
 	/*
 	 * Does this ALTER command takes operation to namespace?
diff --git a/contrib/sepgsql/schema.c b/contrib/sepgsql/schema.c
index fecd02f07a..28c6cb3d03 100644
--- a/contrib/sepgsql/schema.c
+++ b/contrib/sepgsql/schema.c
@@ -67,7 +67,7 @@ sepgsql_schema_post_create(Oid namespaceId)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for namespace %u", namespaceId);
 
-	nspForm = (Form_pg_namespace) GETSTRUCT(tuple);
+	nspForm = GETSTRUCT(pg_namespace, tuple);
 	nsp_name = NameStr(nspForm->nspname);
 	if (strncmp(nsp_name, "pg_temp_", 8) == 0)
 		nsp_name = "pg_temp";
diff --git a/contrib/tcn/tcn.c b/contrib/tcn/tcn.c
index a2de6c385c..ff9990e044 100644
--- a/contrib/tcn/tcn.c
+++ b/contrib/tcn/tcn.c
@@ -134,7 +134,7 @@ triggered_change_notification(PG_FUNCTION_ARGS)
 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
 		if (!HeapTupleIsValid(indexTuple))	/* should not happen */
 			elog(ERROR, "cache lookup failed for index %u", indexoid);
-		index = (Form_pg_index) GETSTRUCT(indexTuple);
+		index = GETSTRUCT(pg_index, indexTuple);
 		/* we're only interested if it is the primary key and valid */
 		if (index->indisprimary && index->indisvalid)
 		{
diff --git a/src/backend/access/brin/brin_validate.c b/src/backend/access/brin/brin_validate.c
index c54c874bc0..06c60b6780 100644
--- a/src/backend/access/brin/brin_validate.c
+++ b/src/backend/access/brin/brin_validate.c
@@ -58,7 +58,7 @@ brinvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -68,7 +68,7 @@ brinvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -80,7 +80,7 @@ brinvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/* Check procedure numbers and function signatures */
@@ -146,7 +146,7 @@ brinvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 
 		/* Check that only allowed strategy numbers exist */
 		if (oprform->amopstrategy < 1 || oprform->amopstrategy > 63)
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index 609329bb21..e58c1ff436 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -1393,7 +1393,7 @@ extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
 	if (isnull)
 		return NULL;
 
-	classForm = (Form_pg_class) GETSTRUCT(tuple);
+	classForm = GETSTRUCT(pg_class, tuple);
 
 	/* Parse into appropriate format; don't error out here */
 	switch (classForm->relkind)
diff --git a/src/backend/access/common/tupdesc.c b/src/backend/access/common/tupdesc.c
index d6fb261e20..dfad4a8dfa 100644
--- a/src/backend/access/common/tupdesc.c
+++ b/src/backend/access/common/tupdesc.c
@@ -635,7 +635,7 @@ TupleDescInitEntry(TupleDesc desc,
 	tuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(oidtypeid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for type %u", oidtypeid);
-	typeForm = (Form_pg_type) GETSTRUCT(tuple);
+	typeForm = GETSTRUCT(pg_type, tuple);
 
 	att->atttypid = oidtypeid;
 	att->attlen = typeForm->typlen;
diff --git a/src/backend/access/gin/ginvalidate.c b/src/backend/access/gin/ginvalidate.c
index 44f2ff205d..a873ab8b70 100644
--- a/src/backend/access/gin/ginvalidate.c
+++ b/src/backend/access/gin/ginvalidate.c
@@ -53,7 +53,7 @@ ginvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -66,7 +66,7 @@ ginvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -78,7 +78,7 @@ ginvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/*
@@ -172,7 +172,7 @@ ginvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 
 		/* TODO: Check that only allowed strategy numbers exist */
 		if (oprform->amopstrategy < 1 || oprform->amopstrategy > 63)
diff --git a/src/backend/access/gist/gistvalidate.c b/src/backend/access/gist/gistvalidate.c
index 95beca05fe..ce87ea3f9e 100644
--- a/src/backend/access/gist/gistvalidate.c
+++ b/src/backend/access/gist/gistvalidate.c
@@ -54,7 +54,7 @@ gistvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -67,7 +67,7 @@ gistvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -79,7 +79,7 @@ gistvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 		bool		ok;
 
 		/*
@@ -174,7 +174,7 @@ gistvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 		Oid			op_rettype;
 
 		/* TODO: Check that only allowed strategy numbers exist */
diff --git a/src/backend/access/hash/hashvalidate.c b/src/backend/access/hash/hashvalidate.c
index 10bf26ce7c..8f8712a552 100644
--- a/src/backend/access/hash/hashvalidate.c
+++ b/src/backend/access/hash/hashvalidate.c
@@ -67,7 +67,7 @@ hashvalidate(Oid opclassoid)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	opfamilyoid = classform->opcfamily;
 	opcintype = classform->opcintype;
@@ -77,7 +77,7 @@ hashvalidate(Oid opclassoid)
 	familytup = SearchSysCache1(OPFAMILYOID, ObjectIdGetDatum(opfamilyoid));
 	if (!HeapTupleIsValid(familytup))
 		elog(ERROR, "cache lookup failed for operator family %u", opfamilyoid);
-	familyform = (Form_pg_opfamily) GETSTRUCT(familytup);
+	familyform = GETSTRUCT(pg_opfamily, familytup);
 
 	opfamilyname = NameStr(familyform->opfname);
 
@@ -89,7 +89,7 @@ hashvalidate(Oid opclassoid)
 	for (i = 0; i < proclist->n_members; i++)
 	{
 		HeapTuple	proctup = &proclist->members[i]->tuple;
-		Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+		Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 
 		/*
 		 * All hash functions should be registered with matching left/right
@@ -149,7 +149,7 @@ hashvalidate(Oid opclassoid)
 	for (i = 0; i < oprlist->n_members; i++)
 	{
 		HeapTuple	oprtup = &oprlist->members[i]->tuple;
-		Form_pg_amop oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+		Form_pg_amop oprform = GETSTRUCT(pg_amop, oprtup);
 
 		/* Check that only allowed strategy numbers exist */
 		if (oprform->amopstrategy < 1 ||
@@ -299,7 +299,7 @@ check_hash_func_signature(Oid funcid, int16 amprocnum, Oid argtype)
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(tp);
+	procform = GETSTRUCT(pg_proc, tp);
 
 	if (procform->prorettype != restype || procform->proretset ||
 		procform->pronargs != nargs)
diff --git a/src/backend/access/index/amapi.c b/src/backend/access/index/amapi.c
index 2b028e1950..243d80c2e5 100644
--- a/src/backend/access/index/amapi.c
+++ b/src/backend/access/index/amapi.c
@@ -68,7 +68,7 @@ GetIndexAmRoutineByAmId(Oid amoid, bool noerror)
 		elog(ERROR, "cache lookup failed for access method %u",
 			 amoid);
 	}
-	amform = (Form_pg_am) GETSTRUCT(tuple);
+	amform = GETSTRUCT(pg_am, tuple);
 
 	/* Check if it's an index access method as opposed to some other AM */
 	if (amform->amtype != AMTYPE_INDEX)
@@ -123,7 +123,7 @@ amvalidate(PG_FUNCTION_ARGS)
 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
 	if (!HeapTupleIsValid(classtup))
 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
-	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+	classform = GETSTRUCT(pg_opclass, classtup);
 
 	amoid = classform->opcmethod;
 
